commit 0844524abbb9f0319866eb357b70bee8331d0059
Author: Andreas Kohlbecker <a.kohlbecker@bgbm.org>
Date:   Wed Apr 11 14:14:53 2018 +0200

    switching vom id based to uuid based ui navigation and entity references

diff --git a/src/main/java/eu/etaxonomy/cdm/service/CdmUserHelper.java b/src/main/java/eu/etaxonomy/cdm/service/CdmUserHelper.java
index 27e60bc1..1bdf0641 100644
--- a/src/main/java/eu/etaxonomy/cdm/service/CdmUserHelper.java
+++ b/src/main/java/eu/etaxonomy/cdm/service/CdmUserHelper.java
@@ -10,6 +10,7 @@ package eu.etaxonomy.cdm.service;
 
 import java.io.Serializable;
 import java.util.EnumSet;
+import java.util.UUID;
 
 import org.apache.log4j.Logger;
 import org.springframework.beans.factory.annotation.Autowired;
@@ -158,6 +159,18 @@ public class CdmUserHelper extends VaadinUserHelper implements Serializable {
         return false;
     }
 
+    @Override
+    public boolean userHasPermission(Class<? extends CdmBase> cdmType, UUID entitiyUuid, Object ... args){
+        EnumSet<CRUD> crudSet = crudSetFromArgs(args);
+        try {
+            CdmBase entity = repo.getCommonService().find(cdmType, entitiyUuid);
+            return permissionEvaluator.hasPermission(getAuthentication(), entity, crudSet);
+        } catch (PermissionDeniedException e){
+            //IGNORE
+        }
+        return false;
+    }
+
     @Override
     public boolean userHasPermission(Class<? extends CdmBase> cdmType, Object ... args){
         EnumSet<CRUD> crudSet = crudSetFromArgs(args);
@@ -259,6 +272,20 @@ public class CdmUserHelper extends VaadinUserHelper implements Serializable {
         return createAuthorityFor(username, cdmEntity, crud, property);
     }
 
+    /**
+     * @param username
+     * @param cdmType
+     * @param entitiyUuid
+     * @param crud
+     * @return
+     */
+    @Override
+    public CdmAuthority createAuthorityFor(String username, Class<? extends CdmBase> cdmType, UUID entitiyUuid, EnumSet<CRUD> crud, String property) {
+
+        CdmBase cdmEntity = repo.getCommonService().find(cdmType, entitiyUuid);
+        return createAuthorityFor(username, cdmEntity, crud, property);
+    }
+
     /**
      * {@inheritDoc}
      */
@@ -279,6 +306,17 @@ public class CdmUserHelper extends VaadinUserHelper implements Serializable {
         return createAuthorityFor(userName(), cdmType, entitiyId, crud, property);
     }
 
+    /**
+     * @param cdmType
+     * @param entitiyUuid
+     * @param crud
+     * @return
+     */
+    @Override
+    public CdmAuthority createAuthorityForCurrentUser(Class<? extends CdmBase> cdmType, UUID entitiyUuid, EnumSet<CRUD> crud, String property) {
+        return createAuthorityFor(userName(), cdmType, entitiyUuid, crud, property);
+    }
+
     /**
      * {@inheritDoc}
      */
diff --git a/src/main/java/eu/etaxonomy/cdm/service/IRegistrationWorkingSetService.java b/src/main/java/eu/etaxonomy/cdm/service/IRegistrationWorkingSetService.java
index e13da028..fb088963 100644
--- a/src/main/java/eu/etaxonomy/cdm/service/IRegistrationWorkingSetService.java
+++ b/src/main/java/eu/etaxonomy/cdm/service/IRegistrationWorkingSetService.java
@@ -10,6 +10,7 @@ package eu.etaxonomy.cdm.service;
 
 import java.util.Collection;
 import java.util.Set;
+import java.util.UUID;
 
 import eu.etaxonomy.cdm.api.service.pager.Pager;
 import eu.etaxonomy.cdm.model.common.User;
@@ -31,6 +32,8 @@ public interface IRegistrationWorkingSetService {
      */
     public RegistrationDTO loadDtoById(Integer id);
 
+    public RegistrationDTO loadDtoByUuid(UUID uuid);
+
     public Pager<RegistrationDTO> pageDTOs(Integer pageSize, Integer pageIndex);
 
     public Pager<RegistrationDTO> pageDTOs(User submitter, Collection<RegistrationStatus> includedStatus,
@@ -43,6 +46,12 @@ public interface IRegistrationWorkingSetService {
      */
     public RegistrationWorkingSet loadWorkingSetByReferenceID(Integer referenceID) throws RegistrationValidationException;
 
-    public Set<RegistrationDTO> loadBlockingRegistrations(Integer blockedRegistrationId);
+    /**
+     * @param referenceID
+     * @return
+     */
+    public RegistrationWorkingSet loadWorkingSetByReferenceUuid(UUID referenceUuid) throws RegistrationValidationException;
+
+    public Set<RegistrationDTO> loadBlockingRegistrations(UUID blockedRegistrationUuid);
 
 }
diff --git a/src/main/java/eu/etaxonomy/cdm/service/ISpecimenTypeDesignationWorkingSetService.java b/src/main/java/eu/etaxonomy/cdm/service/ISpecimenTypeDesignationWorkingSetService.java
index 6df9c542..a814e8fb 100644
--- a/src/main/java/eu/etaxonomy/cdm/service/ISpecimenTypeDesignationWorkingSetService.java
+++ b/src/main/java/eu/etaxonomy/cdm/service/ISpecimenTypeDesignationWorkingSetService.java
@@ -8,6 +8,8 @@
 */
 package eu.etaxonomy.cdm.service;
 
+import java.util.UUID;
+
 import eu.etaxonomy.cdm.model.common.IdentifiableEntity;
 import eu.etaxonomy.cdm.model.common.VersionableEntity;
 import eu.etaxonomy.cdm.model.name.Registration;
@@ -21,13 +23,14 @@ import eu.etaxonomy.cdm.vaadin.model.registration.SpecimenTypeDesignationWorking
  */
 public interface ISpecimenTypeDesignationWorkingSetService {
 
-    public SpecimenTypeDesignationWorkingSetDTO<Registration> create(int registrationId, int publicationId, int typifiedNameId);
+    public SpecimenTypeDesignationWorkingSetDTO<Registration> create(UUID registrationUuid, UUID publicationUuid, UUID typifiedNameUuid);
 
     /**
      * @param id the CDM Entity id
      * @return
      */
-    public SpecimenTypeDesignationWorkingSetDTO<Registration> loadDtoByIds(int registrationId, TypedEntityReference<? extends IdentifiableEntity<?>> baseEntityRef);
+    public SpecimenTypeDesignationWorkingSetDTO<Registration> load(UUID registrationUuid,
+            TypedEntityReference<? extends IdentifiableEntity<?>> baseEntityRef);
 
     SpecimenTypeDesignationWorkingSetDTO<Registration> fixMissingFieldUnit(SpecimenTypeDesignationWorkingSetDTO<Registration> bean);
 
diff --git a/src/main/java/eu/etaxonomy/cdm/service/RegistrationWorkingSetService.java b/src/main/java/eu/etaxonomy/cdm/service/RegistrationWorkingSetService.java
index 2f14e755..c3f2f1f3 100644
--- a/src/main/java/eu/etaxonomy/cdm/service/RegistrationWorkingSetService.java
+++ b/src/main/java/eu/etaxonomy/cdm/service/RegistrationWorkingSetService.java
@@ -15,8 +15,10 @@ import java.util.HashSet;
 import java.util.List;
 import java.util.Optional;
 import java.util.Set;
+import java.util.UUID;
 
 import org.apache.log4j.Logger;
+import org.hibernate.Hibernate;
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.beans.factory.annotation.Qualifier;
 import org.springframework.stereotype.Service;
@@ -152,6 +154,18 @@ public class RegistrationWorkingSetService implements IRegistrationWorkingSetSer
     }
 
 
+    /**
+     * @param id the Registration entity id
+     * @return
+     */
+    @Override
+    public RegistrationDTO loadDtoByUuid(UUID uuid) {
+        Registration reg = repo.getRegistrationService().load(uuid, REGISTRATION_INIT_STRATEGY);
+        inititializeSpecimen(reg);
+        return new RegistrationDTO(reg);
+    }
+
+
     @Override
     public Pager<RegistrationDTO> pageDTOs(Integer pageSize, Integer pageIndex) {
 
@@ -178,6 +192,23 @@ public class RegistrationWorkingSetService implements IRegistrationWorkingSetSer
         return dtoPager;
     }
 
+    /**
+     * {@inheritDoc}
+     * @throws RegistrationValidationException
+     */
+    @Override
+    public RegistrationWorkingSet loadWorkingSetByReferenceUuid(UUID referenceUuid) throws RegistrationValidationException {
+
+        Reference reference = repo.getReferenceService().find(referenceUuid);
+        repo.getReferenceService().load(reference.getUuid()); // needed to avoid the problem described in #7331
+
+        Pager<Registration> pager = repo.getRegistrationService().page(Optional.of(reference), null, null, null, REGISTRATION_INIT_STRATEGY);
+
+        /* for debugging https://dev.e-taxonomy.eu/redmine/issues/7331 */
+        // debugIssue7331(pager);
+        return new RegistrationWorkingSet(makeDTOs(pager.getRecords()));
+    }
+
     /**
      * {@inheritDoc}
      * @throws RegistrationValidationException
@@ -190,7 +221,18 @@ public class RegistrationWorkingSetService implements IRegistrationWorkingSetSer
 
         Pager<Registration> pager = repo.getRegistrationService().page(Optional.of(reference), null, null, null, REGISTRATION_INIT_STRATEGY);
 
-        /* for debugging https://dev.e-taxonomy.eu/redmine/issues/7331
+        /* for debugging https://dev.e-taxonomy.eu/redmine/issues/7331 */
+        // debugIssue7331(pager);
+
+        return new RegistrationWorkingSet(makeDTOs(pager.getRecords()));
+    }
+
+
+    /**
+     * @param pager
+     */
+    @SuppressWarnings("unused")
+    private void debugIssue7331(Pager<Registration> pager) {
         for(Registration reg : pager.getRecords()){
             if(reg.getName() != null && reg.getName().getNomenclaturalReference().getAuthorship() != null){
                 Reference ref = (Reference) reg.getName().getNomenclaturalReference();
@@ -201,14 +243,12 @@ public class RegistrationWorkingSetService implements IRegistrationWorkingSetSer
                 logger.debug("NO AUTHORS");
             }
         }
-        */
-        return new RegistrationWorkingSet(makeDTOs(pager.getRecords()));
     }
 
     @Override
-    public Set<RegistrationDTO> loadBlockingRegistrations(Integer blockedRegistrationId){
+    public Set<RegistrationDTO> loadBlockingRegistrations(UUID blockedRegistrationUuid){
 
-        Registration registration = repo.getRegistrationService().load(blockedRegistrationId, BLOCKING_REGISTRATION_INIT_STRATEGY);
+        Registration registration = repo.getRegistrationService().load(blockedRegistrationUuid, BLOCKING_REGISTRATION_INIT_STRATEGY);
         Set<Registration> registrations = registration.getBlockedBy();
 
         Set<RegistrationDTO> blockingSet = new HashSet<>();
diff --git a/src/main/java/eu/etaxonomy/cdm/service/SpecimenTypeDesignationWorkingSetServiceImpl.java b/src/main/java/eu/etaxonomy/cdm/service/SpecimenTypeDesignationWorkingSetServiceImpl.java
index 0b9c5d4d..ef9221ed 100644
--- a/src/main/java/eu/etaxonomy/cdm/service/SpecimenTypeDesignationWorkingSetServiceImpl.java
+++ b/src/main/java/eu/etaxonomy/cdm/service/SpecimenTypeDesignationWorkingSetServiceImpl.java
@@ -13,6 +13,7 @@ import java.util.HashSet;
 import java.util.Iterator;
 import java.util.List;
 import java.util.Set;
+import java.util.UUID;
 
 import org.hibernate.Session;
 import org.jboss.logging.Logger;
@@ -85,11 +86,11 @@ public class SpecimenTypeDesignationWorkingSetServiceImpl implements ISpecimenTy
      * {@inheritDoc}
      */
     @Override
-    public SpecimenTypeDesignationWorkingSetDTO<Registration> create(int registrationId, int publicationId, int typifiedNameId) {
+    public SpecimenTypeDesignationWorkingSetDTO<Registration> create(UUID registrationUuid, UUID publicationUuid, UUID typifiedNameUuid) {
         FieldUnit newfieldUnit = FieldUnit.NewInstance();
-        Registration reg = repo.getRegistrationService().load(registrationId, RegistrationWorkingSetService.REGISTRATION_INIT_STRATEGY);
-        TaxonName typifiedName = repo.getNameService().load(typifiedNameId, TAXON_NAME_INIT_STRATEGY);
-        Reference citation = repo.getReferenceService().load(publicationId, Arrays.asList("$"));
+        Registration reg = repo.getRegistrationService().load(registrationUuid, RegistrationWorkingSetService.REGISTRATION_INIT_STRATEGY);
+        TaxonName typifiedName = repo.getNameService().load(typifiedNameUuid, TAXON_NAME_INIT_STRATEGY);
+        Reference citation = repo.getReferenceService().load(publicationUuid, Arrays.asList("$"));
         SpecimenTypeDesignationWorkingSetDTO<Registration> workingSetDto = new SpecimenTypeDesignationWorkingSetDTO<Registration>(reg, newfieldUnit, citation, typifiedName);
         return workingSetDto;
     }
@@ -99,8 +100,8 @@ public class SpecimenTypeDesignationWorkingSetServiceImpl implements ISpecimenTy
      */
     @Override
     @Transactional
-    public SpecimenTypeDesignationWorkingSetDTO<Registration> loadDtoByIds(int registrationId, TypedEntityReference<? extends IdentifiableEntity<?>> baseEntityRef) {
-        RegistrationDTO regDTO = registrationWorkingSetService.loadDtoById(registrationId);
+    public SpecimenTypeDesignationWorkingSetDTO<Registration> load(UUID registrationUuid, TypedEntityReference<? extends IdentifiableEntity<?>> baseEntityRef) {
+        RegistrationDTO regDTO = registrationWorkingSetService.loadDtoByUuid(registrationUuid);
         // find the working set
         TypeDesignationWorkingSet typeDesignationWorkingSet = regDTO.getTypeDesignationWorkingSet(baseEntityRef);
         SpecimenTypeDesignationWorkingSetDTO<Registration> workingSetDto = regDTO.getSpecimenTypeDesignationWorkingSetDTO(typeDesignationWorkingSet.getBaseEntityReference());
@@ -114,7 +115,7 @@ public class SpecimenTypeDesignationWorkingSetServiceImpl implements ISpecimenTy
             // in case the base unit of the working set is not a FieldUnit all contained TypeDesignations must be modified
             // so that they are based on an empty FieldUnit with an associated Gathering Event
 
-            Registration reg = repo.getRegistrationService().find(bean.getOwner().getId());
+            Registration reg = repo.getRegistrationService().find(bean.getOwner().getUuid());
             RegistrationDTO regDTO = new RegistrationDTO(reg);
 
             FieldUnit fieldUnit = FieldUnit.NewInstance();
@@ -124,7 +125,7 @@ public class SpecimenTypeDesignationWorkingSetServiceImpl implements ISpecimenTy
 
             VersionableEntity baseEntity = bean.getBaseEntity();
             Set<TypeDesignationBase> typeDesignations = regDTO.getTypeDesignationsInWorkingSet(
-                    new TypedEntityReference(baseEntity.getClass(), baseEntity.getId(), baseEntity.toString())
+                    new TypedEntityReference(baseEntity.getClass(), baseEntity.getUuid(), baseEntity.toString())
                     );
             for(TypeDesignationBase td : typeDesignations){
                 DerivationEvent de = DerivationEvent.NewInstance();//
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/component/registration/RegistrationItem.java b/src/main/java/eu/etaxonomy/cdm/vaadin/component/registration/RegistrationItem.java
index 9bf6aac2..ed2f486b 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/component/registration/RegistrationItem.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/component/registration/RegistrationItem.java
@@ -13,6 +13,7 @@ import static eu.etaxonomy.cdm.vaadin.component.registration.RegistrationStyles.
 import java.util.Collection;
 import java.util.EnumSet;
 import java.util.Set;
+import java.util.UUID;
 
 import org.joda.time.DateTime;
 import org.joda.time.format.ISODateTimeFormat;
@@ -191,10 +192,10 @@ public class RegistrationItem extends GridLayout {
         this.regDto = regDto;
 
         NavigationEvent navigationEvent = null;
-        if(regDto.getCitationID() != null) {
+        if(regDto.getCitationUuid() != null) {
             navigationEvent = new NavigationEvent(
                     RegistrationWorksetViewBean.NAME,
-                    Integer.toString(regDto.getCitationID())
+                    regDto.getCitationUuid().toString()
                     );
         } else {
             setComponentError(new UserError("Citation is missing"));
@@ -208,11 +209,11 @@ public class RegistrationItem extends GridLayout {
         this.parentView = parentView;
 
         ReferenceEditorAction referenceEditorAction = null;
-        if(workingSet.getCitationId() != null){
-            if(UserHelper.fromSession().userHasPermission(Reference.class, workingSet.getCitationId(), CRUD.UPDATE)){
-                referenceEditorAction = new ReferenceEditorAction(EditorActionType.EDIT, workingSet.getCitationId(), null, parentView);
+        if(workingSet.getCitationUuid() != null){
+            if(UserHelper.fromSession().userHasPermission(Reference.class, workingSet.getCitationUuid(), CRUD.UPDATE)){
+                referenceEditorAction = new ReferenceEditorAction(EditorActionType.EDIT, workingSet.getCitationUuid(), null, parentView);
             }
-            PermissionDebugUtils.addGainPerEntityPermissionButton(this, Reference.class, workingSet.getCitationId(), EnumSet.of(CRUD.UPDATE, CRUD.DELETE), null);
+            PermissionDebugUtils.addGainPerEntityPermissionButton(this, Reference.class, workingSet.getCitationUuid(), EnumSet.of(CRUD.UPDATE, CRUD.DELETE), null);
         } else {
             if(UserHelper.fromSession().userHasPermission(Reference.class, CRUD.CREATE, null, null, parentView)){
                 referenceEditorAction = new ReferenceEditorAction(EditorActionType.ADD);
@@ -245,13 +246,13 @@ public class RegistrationItem extends GridLayout {
             getMessageButton().addClickListener(e -> {
                 ShowDetailsEvent detailsEvent;
                 if(regDto != null){
-                    detailsEvent = new ShowDetailsEvent<RegistrationDTO, Integer>(
+                    detailsEvent = new ShowDetailsEvent<RegistrationDTO, UUID>(
                             e,
                             RegistrationDTO.class,
-                            regDto.getId(),
+                            regDto.getUuid(),
                             VALIDATION_PROBLEMS);
                 } else {
-                    detailsEvent = new ShowDetailsEvent<RegistrationWorkingSet, Integer>(
+                    detailsEvent = new ShowDetailsEvent<RegistrationWorkingSet, UUID>(
                             e,
                             RegistrationWorkingSet.class,
                             null,
@@ -329,8 +330,8 @@ public class RegistrationItem extends GridLayout {
         }
     }
 
-    public int getRegistrationId(){
-        return regDto.getId();
+    public UUID getRegistrationUuid(){
+        return regDto.getUuid();
     }
 
     /**
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/component/registration/RegistrationItemNameAndTypeButtons.java b/src/main/java/eu/etaxonomy/cdm/vaadin/component/registration/RegistrationItemNameAndTypeButtons.java
index a1598228..15914a9e 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/component/registration/RegistrationItemNameAndTypeButtons.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/component/registration/RegistrationItemNameAndTypeButtons.java
@@ -11,6 +11,7 @@ package eu.etaxonomy.cdm.vaadin.component.registration;
 import java.util.ArrayList;
 import java.util.EnumSet;
 import java.util.List;
+import java.util.UUID;
 
 import org.apache.log4j.Logger;
 
@@ -74,14 +75,14 @@ public class RegistrationItemNameAndTypeButtons extends CompositeStyledComponent
         if(regDto.getNameRef() != null){
             Button nameButton = new Button("Name:");
             nameButton.setDescription("Edit the Name");
-            nameIdButton = new IdButton<TaxonName>(TaxonName.class, regDto.getNameRef().getId(), nameButton);
+            nameIdButton = new IdButton<TaxonName>(TaxonName.class, regDto.getNameRef().getUuid(), nameButton);
             Label nameLabel = new Label(regDto.getNameRef().getLabel());
             nameLabel.setWidthUndefined();
             boolean userHasPermission = UserHelper.fromSession().userHasPermission(regDto.registration().getName(), CRUD.UPDATE);
             nameButton.setReadOnly(isRegistrationLocked || ! userHasPermission);
 
             addComponent(nameIdButton.getButton());
-            PermissionDebugUtils.addGainPerEntityPermissionButton(this, TaxonName.class, regDto.getNameRef().getId(),
+            PermissionDebugUtils.addGainPerEntityPermissionButton(this, TaxonName.class, regDto.getNameRef().getUuid(),
                     EnumSet.of(CRUD.UPDATE, CRUD.DELETE), null);
             addComponent(nameLabel);
         } else {
@@ -91,7 +92,7 @@ public class RegistrationItemNameAndTypeButtons extends CompositeStyledComponent
                 addComponent(nameLabel);
             }
         }
-        boolean userHasAddPermission = UserHelper.fromSession().userHasPermission(Registration.class, regDto.getId(), CRUD.UPDATE);
+        boolean userHasAddPermission = UserHelper.fromSession().userHasPermission(Registration.class, regDto.getUuid(), CRUD.UPDATE);
         if(regDto.getOrderdTypeDesignationWorkingSets() != null){
             for(TypedEntityReference<TypeDesignationBase<?>> baseEntityRef : regDto.getOrderdTypeDesignationWorkingSets().keySet()) {
                 TypeDesignationWorkingSet typeDesignationWorkingSet = regDto.getOrderdTypeDesignationWorkingSets().get(baseEntityRef);
@@ -99,12 +100,12 @@ public class RegistrationItemNameAndTypeButtons extends CompositeStyledComponent
                 String buttonLabel = SpecimenOrObservationBase.class.isAssignableFrom(baseEntityRef.getType()) ? "Type": "NameType";
                 Button tdButton = new Button(buttonLabel + ":");
                 tdButton.setDescription("Edit the type designation working set");
-                boolean userHasUpdatePermission = UserHelper.fromSession().userHasPermission(baseEntityRef.getType(), baseEntityRef.getId(), CRUD.UPDATE, CRUD.DELETE);
+                boolean userHasUpdatePermission = UserHelper.fromSession().userHasPermission(baseEntityRef.getType(), baseEntityRef.getUuid(), CRUD.UPDATE, CRUD.DELETE);
                 tdButton.setReadOnly(isRegistrationLocked || !userHasUpdatePermission);
                 addComponent(tdButton);
 
                 PermissionDebugUtils.addGainPerEntityPermissionButton(this, SpecimenOrObservationBase.class,
-                        baseEntityRef.getId(), EnumSet.of(CRUD.UPDATE, CRUD.DELETE), RegistrationStatus.PREPARATION.name());
+                        baseEntityRef.getUuid(), EnumSet.of(CRUD.UPDATE, CRUD.DELETE), RegistrationStatus.PREPARATION.name());
 
                 typeDesignationButtons.add(new TypeDesignationWorkingSetButton(
                         typeDesignationWorkingSet.getWorkingsetType(),
@@ -207,21 +208,21 @@ public class RegistrationItemNameAndTypeButtons extends CompositeStyledComponent
     }
 
     public class IdButton<T> {
-        private Integer id;
+        private UUID uuid;
         private Class<T> entityType;
         private Button button;
 
-        public IdButton(Class<T> type, Integer id, Button button){
+        public IdButton(Class<T> type, UUID uuid, Button button){
             this.entityType = type;
-            this.id = id;
+            this.uuid = uuid;
             this.button = button;
         }
 
         /**
          * @return the id
          */
-        public Integer getId() {
-            return id;
+        public UUID getUuid() {
+            return uuid;
         }
 
         /**
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/event/AbstractEditorAction.java b/src/main/java/eu/etaxonomy/cdm/vaadin/event/AbstractEditorAction.java
index e4892020..65892600 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/event/AbstractEditorAction.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/event/AbstractEditorAction.java
@@ -9,6 +9,7 @@
 package eu.etaxonomy.cdm.vaadin.event;
 
 import java.util.Stack;
+import java.util.UUID;
 
 import com.vaadin.ui.Component;
 
@@ -38,8 +39,8 @@ public abstract class AbstractEditorAction extends AbstractEntityEvent<EditorAct
         this(action, null, source, sourceView);
     }
 
-    public AbstractEditorAction(EditorActionType action, Integer entityId, Component source, AbstractView sourceView) {
-        this(action, entityId, source, sourceView, null);
+    public AbstractEditorAction(EditorActionType action, UUID entityUuid, Component source, AbstractView sourceView) {
+        this(action, entityUuid, source, sourceView, null);
     }
 
     /**
@@ -57,9 +58,9 @@ public abstract class AbstractEditorAction extends AbstractEntityEvent<EditorAct
      *            Editor actions from previous views and editors that lead to the point
      *            from where this action is spawned.
      */
-    public AbstractEditorAction(EditorActionType action, Integer entityId, Component source, AbstractView sourceView,
+    public AbstractEditorAction(EditorActionType action, UUID entityUuid, Component source, AbstractView sourceView,
             Stack<EditorActionContext> context) {
-        super(action, entityId, sourceView);
+        super(action, entityUuid, sourceView);
         this.sourceComponent = source;
         this.context = context;
     }
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/event/AbstractEntityEvent.java b/src/main/java/eu/etaxonomy/cdm/vaadin/event/AbstractEntityEvent.java
index abc4b35e..403d1b75 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/event/AbstractEntityEvent.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/event/AbstractEntityEvent.java
@@ -8,6 +8,8 @@
 */
 package eu.etaxonomy.cdm.vaadin.event;
 
+import java.util.UUID;
+
 import eu.etaxonomy.vaadin.mvp.AbstractView;
 
 /**
@@ -17,14 +19,14 @@ import eu.etaxonomy.vaadin.mvp.AbstractView;
  */
 public abstract class AbstractEntityEvent<T extends Enum> {
 
-    private Integer entityId = null;
+    private UUID entityUuid = null;
 
     protected T type;
 
     private AbstractView sourceView = null;
 
-    public AbstractEntityEvent(T type, Integer entityId, AbstractView sourceView) {
-        this.entityId = entityId;
+    public AbstractEntityEvent(T type, UUID entityUuid, AbstractView sourceView) {
+        this.entityUuid = entityUuid;
         this.type = type;
         this.sourceView = sourceView;
         if(type == null){
@@ -35,8 +37,8 @@ public abstract class AbstractEntityEvent<T extends Enum> {
     /**
      * @return the entityId
      */
-    public Integer getEntityId() {
-        return entityId;
+    public UUID getEntityUuid() {
+        return entityUuid;
     }
 
     public T getType() {
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/event/CollectionEditorAction.java b/src/main/java/eu/etaxonomy/cdm/vaadin/event/CollectionEditorAction.java
index 400e67d7..47fee538 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/event/CollectionEditorAction.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/event/CollectionEditorAction.java
@@ -8,6 +8,8 @@
 */
 package eu.etaxonomy.cdm.vaadin.event;
 
+import java.util.UUID;
+
 import com.vaadin.ui.Component;
 
 import eu.etaxonomy.vaadin.event.EditorActionType;
@@ -40,8 +42,8 @@ public class CollectionEditorAction extends AbstractEditorAction {
      * @param source
      * @param sourceView
      */
-    public CollectionEditorAction(EditorActionType action, Integer entityId, Component source, AbstractView sourceView) {
-        super(action, entityId, source, sourceView);
+    public CollectionEditorAction(EditorActionType action, UUID entityUuid, Component source, AbstractView sourceView) {
+        super(action, entityUuid, source, sourceView);
     }
 
 }
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/event/EntityChangeEvent.java b/src/main/java/eu/etaxonomy/cdm/vaadin/event/EntityChangeEvent.java
index ac53f51e..98588916 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/event/EntityChangeEvent.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/event/EntityChangeEvent.java
@@ -33,7 +33,7 @@ public class EntityChangeEvent<T extends CdmBase> extends AbstractEntityEvent<En
     private T entity;
 
     public EntityChangeEvent(T entity, Type type, AbstractView sourceView) {
-        super(type, entity.getId(), sourceView);
+        super(type, entity.getUuid(), sourceView);
         this.entityType = (Class<T>) entity.getClass();
         this.entity = entity;
     }
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/event/ReferenceEditorAction.java b/src/main/java/eu/etaxonomy/cdm/vaadin/event/ReferenceEditorAction.java
index a4097fcf..d49ce039 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/event/ReferenceEditorAction.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/event/ReferenceEditorAction.java
@@ -8,6 +8,8 @@
 */
 package eu.etaxonomy.cdm.vaadin.event;
 
+import java.util.UUID;
+
 import com.vaadin.ui.Component;
 
 import eu.etaxonomy.vaadin.event.EditorActionType;
@@ -40,8 +42,8 @@ public class ReferenceEditorAction extends AbstractEditorAction {
      * @param source
      * @param sourceView
      */
-    public ReferenceEditorAction(EditorActionType action, Integer entityId, Component source, AbstractView sourceView) {
-        super(action, entityId, source, sourceView);
+    public ReferenceEditorAction(EditorActionType action, UUID entityUuid, Component source, AbstractView sourceView) {
+        super(action, entityUuid, source, sourceView);
     }
 
 }
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/event/RegistrationEditorAction.java b/src/main/java/eu/etaxonomy/cdm/vaadin/event/RegistrationEditorAction.java
index 216d0ae8..67cecda5 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/event/RegistrationEditorAction.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/event/RegistrationEditorAction.java
@@ -8,6 +8,8 @@
 */
 package eu.etaxonomy.cdm.vaadin.event;
 
+import java.util.UUID;
+
 import com.vaadin.ui.Component;
 
 import eu.etaxonomy.vaadin.event.EditorActionType;
@@ -41,8 +43,8 @@ public class RegistrationEditorAction extends AbstractEditorAction {
      * @param source
      * @param sourceView
      */
-    public RegistrationEditorAction(EditorActionType action, Integer entityId, Component source, AbstractView sourceView) {
-        super(action, entityId, source, sourceView);
+    public RegistrationEditorAction(EditorActionType action, UUID entityUuid, Component source, AbstractView sourceView) {
+        super(action, entityUuid, source, sourceView);
     }
 
 
diff --git a/src/main/java/eu/etaxonomy/cdm/vaadin/event/TaxonNameEditorAction.java b/src/main/java/eu/etaxonomy/cdm/vaadin/event/TaxonNameEditorAction.java
index 7d4f9592..799b1323 100644
--- a/src/main/java/eu/etaxonomy/cdm/vaadin/event/TaxonNameEditorAction.java
+++ b/src/main/java/eu/etaxonomy/cdm/vaadin/event/TaxonNameEditorAction.java
@@ -9,6 +9,7 @@
 package eu.etaxonomy.cdm.vaadin.event;
 
 import java.util.Stack;
+import java.util.UUID;
 
 import com.vaadin.ui.Component;
 
@@ -41,8 +42,8 @@ public class TaxonNameEditorAction extends AbstractEditorAction {
      * @param source
      * @param sourceView
      */
-    public TaxonNameEditorAction(EditorActionType action, Integer entityId, Component source, AbstractView sourceView) {
-        super(action, entityId, source, sourceView);
+    public TaxonNameEditorAction(EditorActionType action, UUID entityUuid, Component source, AbstractView sourceView) {
+        super(action, entityUuid, source, sourceView);
     }
 
     /**
@@ -52,9 +53,9 @@ public class TaxonNameEditorAction extends AbstractEditorAction {
      * @param sourceView
      * @param context
      */
-    public TaxonNameEditorAction(EditorActionType action, Integer entityId, Component source, AbstractView sourceView,
+    public TaxonNameEditorAction(EditorActionType action, UUID entityUuid, Component source, AbstractView sourceView,
             Stack<EditorActionContext> context) {
-        super(action, entityId, source, sourceView, context);
+        super(action, entityUuid, source, sourceView, context);
     }
 
 
